/***************************************************************************
 *   Copyright (C) 2006-2007 by Linares Georges                                 
 *   georges.linares@archipel-software.com                                 
 *   This program is free software; you can redistribute it and/or modify  
 *   it under the terms of the GNU General Public License as published by  
 *   the Free Software Foundation; either version 2 of the License, or     
 *   (at your option) any later version.                                   
 *                                                                         
 *   This program is distributed in the hope that it will be useful,       
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
 *   GNU General Public License for more details.                          
 *                                                                         
 *   You should have received a copy of the GNU General Public License     
 *   along with this program; if not, write to the                         
 *   Free Software Foundation, Inc.,                                       
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            
 ***************************************************************************/
//~/.kde/share/apps/konqueror/servicemenus/

#include <qfiledialog.h>
#include <qdom.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qprocess.h>
#include <qtimer.h>
#include <qfile.h>

#include "frmanalyse.h"

// Répertoires et chemins

extern QString App_Folder;
extern QString app;
QString Chemin;
QString languelng;

//répertoire cron
QDir cron_daily( "/etc/cron.daily/" );
QDir cron_hourly( "/etc/cron.hourly/" );
QDir cron_monthly( "/etc/cron.monthly/" );
QDir cron_weekly( "/etc/cron.weekly/" );

//variables objets (boite à cocher)
QString vNoScanArchive;
QString vNoScanMailbox;
QString vNoScanPakedProg;
QString vScanOneLevel;
QString vLevelMaxArchive;
QString vLevelMaxFolder;
QString vScanExtension;
QString vExcludeExtension;
QString vQuarantine;
QString vSuspectCopy;
QString vSuspectMove;

//variable mise à jour automatique
QString vHeure;
QString vMois;
QString vSemaine;
QString vJours;
QString vBdscan;

//variable texte
QString cScanExtension;
QString cExcludeExtension;
//QString cQuarantineFolder;
//QString cLogFolder;

QString vActionToDo;
QString vSuspectedFile;
QString vCreateLog;
QString vLanguage;
QString vThemes;
QString vCountDays;
QString vActiveAlert;
QString vQuarantineFolder;
QString vLogFolder;
QString vDepthMaxArchive;
QString vDepthMaxFolder;
QDateTime  vLastModified;

QString fscan;
int information;

//Variables numériques associées aux objets
QString vnDepthMaxArchive;
QString vnDepthMaxFolder;

QString ScanningFolder;
QProcess * proc;
QTimer  * timer = new QTimer();

bool vrai=true;
int cptPB=1;
QString Appli;
int i;
QString locale ;
QString lng;
QString ths;
QString line;
QString mois;
QString jour;
QString annee;
QString update_txt;
QDate dater;
QDate date;
QString ligneA;
int val;


/* PROCEDURE D'INITIALISATION DU PROGRAMME 
   ON RECUPERE LES DIFFERENTES INFORMATIONS DU FICHIER DE CONFIGURATION */
void frmprincipal::init()
{      
     leScanFolder->setText( "/" );//INITIALISATION DU REPERTOIRE  A SCANNER
     
    // Choix de la langue du logiciel on liste les fichiers qm puis on les tronques afin de garder le nom de la langue.
    // Puis on effectue une boucle afin de lister les noms des fichiers dans le menu déroulant Langue
    Appli = app;
    QDir dir(Appli);
    QStringList filename = dir.entryList("*.qm");
    for (i = 0; i <(int) filename.size();++i)
    {
	locale = filename[i];
	locale.truncate(locale.find('.'));
	Language->insertItem(locale,i);
    }
    
    //Donne diverses informations sur le logiciel antivirus, son moteur de scan etc.
    proc = new QProcess( this );
    proc->addArgument( "bdscan" );	
    proc->addArgument( "--info" );	
    connect( proc, SIGNAL(readyReadStdout()), this, SLOT(readFromStdout()) );
    connect( proc, SIGNAL(processExited()), this, SLOT(rien()) );
    if ( !proc->start() )
    {
	erreur();
    }
    /*
     Récupération des variables dans le fichier de configuration.
    */
    // fichier de configuration de l'utilisateur
    QDomDocument doc( "file_conf" );
    Chemin = App_Folder + "/.bdfeui.conf";
    QFile file( Chemin );
    if (! file.open( IO_ReadOnly ) ) return;
    if ( !doc.setContent( &file ) ) 
    {
	file.close();
	return;
    }
    file.close(); 
    
    QDomElement docElem = doc.documentElement();
    
    QDomNode n = docElem.firstChild();
    
    QDomElement element = doc.documentElement();
    
    for ( QDomNode n = element.firstChild(); !n.isNull(); n = n.nextSibling() )
    {
	QDomElement e = n.toElement(); 
	if( !e.isNull() ) 
	{
	    // batterie de tests effectuée à partir du fichier de configuration
	    
	    // on vérifie les noms des noeuds et on affecte la variable trouvée aux différents objets
	    
	    //ne pas scanner les archives
	    if ( e.isElement() && e.nodeName() == "noscanarchive" ) 
	    {   
		vNoScanArchive=e.text();
		int a = vNoScanArchive.toInt( &vrai, 10);
		NoScanArchive->setChecked(a);      
	    }
	    // ne pas scanner les boites mails
	    if ( e.isElement() && e.nodeName() == "noscanmailbox" ) 
	    {
		vNoScanMailbox=e.text();
		int b = vNoScanMailbox.toInt( &vrai, 10);
		NoScanMailbox->setChecked(b);
	    }
	    //ne pas scanner les programmes paquet�
	    if ( e.isElement() && e.nodeName() == "noscanpakedprog" ) 
	    {
		vNoScanPakedProg=e.text();
		int c = vNoScanPakedProg.toInt( &vrai, 10);
		NoScanPakedProg->setChecked(c);
	    }  
	    //Niveau de profondeur maximum des archives
	    if ( e.isElement() && e.nodeName() == "levelmaxarchive" ) 
	    {
		vLevelMaxArchive=e.text();
		int f = vLevelMaxArchive.toInt( &vrai, 10);
		LevelMaxArchive->setChecked(f);
	    }
	    //Valeur associée à la profondeur maximum des archives
	    if ( e.isElement() && e.nodeName() == "valdepthmaxarchive" ) 
	    {
		vnDepthMaxArchive=e.text();
		int q = vnDepthMaxArchive.toInt( &vrai, 10);
		sbDepthMaxArchive->setValue(q);
	    }	    
	    //Niveau de profondeur maximum des répertoires
	    if ( e.isElement() && e.nodeName() == "levelmaxfolder" ) 
	    {
		vLevelMaxFolder=e.text();
		int g = vLevelMaxFolder.toInt( &vrai, 10);
		LevelMaxFolder->setChecked(g);
	    }
	    //Valeur associée au niveau de profondeur maximum des répertoires
	    if ( e.isElement() && e.nodeName() == "valdepthmaxfolder" ) 
	    {
		vnDepthMaxFolder=e.text();
		int r = vnDepthMaxFolder.toInt( &vrai, 10);
		sbDepthMaxFolder->setValue(r);
	    }	    
	    //Scanner les extension suivantes
	    if ( e.isElement() && e.nodeName() == "scanextension" ) 
	    {
		vScanExtension=e.text();
		int o = vScanExtension.toInt( &vrai, 10);
		ScanExtension->setChecked(o);
	    }
	    //extension à prendre en compte
	    if (e.isElement() && e.nodeName() == "cscanextension")
	    {
		//leScanExtension->setCurrentText(e.text());
		leScanExtension->setText(e.text());
	    }  	    
	    //Exclure les extensions suivantes
	    if ( e.isElement() && e.nodeName() == "excludeextension" ) 
	    {
		vExcludeExtension=e.text();
		int p = vExcludeExtension.toInt( &vrai, 10);
		ExcludeExtension->setChecked(p);
	    }	   
	    //extension à ne pas prendre en compte
	    if (e.isElement() && e.nodeName() == "cexcludeextension")
	    {
		//leExcludeExtension->setCurrentText(e.text());
		leExcludeExtension->setText(e.text());
	    }	    
	    //Action à entreprendre
	    if ( e.isElement() && e.nodeName() == "actiontodo" ) 
	    {
		vActionToDo=e.text();
		int h = vActionToDo.toInt( &vrai, 10);
		ActionToDo->setCurrentItem(h);
	    } 
	    //Si le fichier est suspect
	    if ( e.isElement() && e.nodeName() == "suspectedfile" ) 
	    {
		vSuspectedFile=e.text();
		int l = vSuspectedFile.toInt( &vrai, 10);
		SuspectedFile->setCurrentItem(l);
	    }  
	    //Nombre de jours séparant la dernière date de mise à jour
	    if ( e.isElement() && e.nodeName() == "countdays" ) 
	    {
		vCountDays=e.text();
		int u = vCountDays.toInt( &vrai, 10);
		CountDays->setValue(u);
	    }	
	    //Activation de l'alerte de mise à jour
	    if ( e.isElement() && e.nodeName() == "activealert" ) 
	    {
		vActiveAlert=e.text();
		int v = vActiveAlert.toInt( &vrai, 10);
		ActiveAlert->setChecked(v);
	    }

                    //activation de l'option de mise à jour MOIS
	    if ( e.isElement() && e.nodeName() == "mois" ) 
	    {
		vMois=e.text();
		int w = vMois.toInt( &vrai, 10);
		rbmois->setChecked(w);
	    }
	    //activation de l'option de mise à jour SEMAINE
	    if ( e.isElement() && e.nodeName() == "semaine" ) 
	    {
		vSemaine=e.text();
		int x = vSemaine.toInt( &vrai, 10);
		rbsemaine->setChecked(x);
	    }
	    //activation de l'option de mise à jour JOURS
	    if ( e.isElement() && e.nodeName() == "jours" ) 
	    {
		vJours=e.text();
		int y = vJours.toInt( &vrai, 10);
		rbjours->setChecked(y);
	    }
	    //activation de l'option de mise à jour HEURE
	    if ( e.isElement() && e.nodeName() == "heure" ) 
	    {
		vHeure=e.text();
		int z = vHeure.toInt( &vrai, 10);
		rbheure->setChecked(z);
	    }
	    
	    //Chemin à récupérer pour le r�ertoire BDSCAN
	    if ( e.isElement() && e.nodeName() == "bdscanfolder" ) 
	    {
		vBdscan = e.text();
		lebdapp->setText(vBdscan);
	    }
	
	    //Chemin �r�up�er pour le répertoire quarantaine
	    if ( e.isElement() && e.nodeName() == "quarantinefolder" ) 
	    {
		vQuarantineFolder = e.text();
		QuarantineFolder->setText(vQuarantineFolder);
	    }	    
	    //Valider la création d'un fichier log
	    if ( e.isElement() && e.nodeName() == "createlog" ) 
	    {
		vCreateLog=e.text();
		int s = vCreateLog.toInt( &vrai, 10);
		CreateLog->setChecked(s);
	    }
	    //Chemin à récupérer pour le fichier log
	    if ( e.isElement() && e.nodeName() == "logfolder" ) 
	    {
		vLogFolder = e.text();
		LogFolder->setText(vLogFolder);
	    }
	    //Langage de l'application
	    if ( e.isElement() && e.nodeName() == "language" ) 
	    {
		vLanguage=e.text();
		int t = vLanguage.toInt( &vrai, 10);
		Language->setCurrentItem(t);
	    }	
	    //Nom complet du langage de l'application
	    if ( e.isElement() && e.nodeName() == "completelanguage" ) 
	    {
		Language->setCurrentText(e.text());
	    }	
	    //Thème choisi (numéro)
	    if ( e.isElement() && e.nodeName() == "themes" ) 
	    {
		vThemes=e.text();
		int t = vThemes.toInt( &vrai, 10);
		Themes->setCurrentItem(t);
	    }
	    //Nom complet du thème choisi
	    if ( e.isElement() && e.nodeName() == "completethemes" ) 
	    {
		Themes->setCurrentText(e.text());
	    }
	    // fin des tests
	}
    }  
    
    lng = Language->currentText();
    ths = Themes->currentText();
    // code pour la mise à jour antivirale
    int val = CountDays->value();	
    
    //récuperation de la date du fichier plugins + ajout de la valeur d'alerte
    //   QFileInfo fi = QString("/opt/bdc/Plugins");
    QFileInfo fi = QString("/opt/BitDefender-scanner/var/lib/scan/Plugins");
    
    vLastModified = fi.lastModified();
    QDate dater = vLastModified.date();
    
    //FIN TRAITEMENT FICHIER
    
    //récupération de la date en cours...
    QDate date = QDate::currentDate();
    
    QVariant d  = dater.day();
    int  m = dater.month();
    QVariant y = dater.year();

    QString mois = QDate::longMonthName (m);
	    
    if (ActiveAlert->isChecked() && dater.addDays(val)<=date) 
    {
	QMessageBox::warning(this, tr("BitDefender Front End"),
			     tr("La base de donnees antivirale n'est plus a jours depuis le ") +d.toString()+" "+mois+" "+y.toString()+" !",QMessageBox::Ok, 0,0);
    }
    if (dater.addDays(val)<=date) 
    {
	pmlInfo->setText(tr("La base de donnees antivirale n'est plus a jour depuis le ") + d.toString()+" "+mois+" "+y.toString()+" !");
	pmlInfo->setPaletteBackgroundColor(QColor(255,0,0));
	tbGeneral->setCurrentPage(1);
    }
    else
    {
	pmlInfo->setText(tr("La base de donnees antivirale est a jour  ( ") + d.toString()+" "+mois+" "+y.toString()+ " )");
	pmlInfo->setPaletteBackgroundColor(QColor(0,255,0));	
    }      
}

void frmprincipal::browseFolder()
{
    // REPERTOIRE A SCANNER
    
    QString parcourir = QFileDialog::getExistingDirectory("/", 0, 0,tr("BitDefender répertoire à scanner"), TRUE, TRUE);
    
    if ( !parcourir.isEmpty() ) {
	leScanFolder->setText(parcourir);
	ScanningFolder = parcourir;
    }
}

void frmprincipal::browseLogFolder()
{
      // REPERTOIRE FICHIER LOG
    
    QString parcourir = QFileDialog::getExistingDirectory("/", 0, 0,tr("BitDefender répertoire du fichier log"), TRUE, TRUE);
    
    if ( !parcourir.isEmpty() ) {
	LogFolder->setText(parcourir);
    }
}


void frmprincipal::browsequarantfolder()
{
      // REPERTOIRE FICHIER QUARANTAINE
    
    QString parcourir = QFileDialog::getExistingDirectory("/", 0, 0,tr("BitDefender répertoire des fichiers quarantaines"), TRUE, TRUE);
    
    if ( !parcourir.isEmpty() ) {
         QuarantineFolder->setText(parcourir);
         vQuarantineFolder=parcourir;

    }
}

void frmprincipal::browsebdscanfolder()
{
      // REPERTOIRE FICHIER QUARANTAINE
    
    QString parcourir = QFileDialog::getExistingDirectory("/", 0, 0,tr("BitDefender répertoire du fichier bdscan"), TRUE, TRUE);
    
    if ( !parcourir.isEmpty() ) {
         lebdapp->setText(parcourir);
    }
}

// MODIFICATION DES EXTENSIONS SUITE A LA MISE A JOUR DU PRODUIT DE BITDEFENDER FOR UNICES

//PROCEDURE DE VERIFICATION SI "SCANNER LES EXTENSIONS SUIVANTES EST ACTIVE OU NON"
void frmprincipal::extension()
{
    if  (ScanExtension->isChecked())
    {
	leScanExtension->setEnabled(true);
	leScanExtension->setFocus();
    }
    else
    {
	leScanExtension->setEnabled(false);  
	leScanFolder->setFocus();       
    }
}

//RECUPERATION DES VARIABLES
void frmprincipal::recup_toutes_variables()
{
    if (NoScanArchive->isChecked())
    {
	vNoScanArchive = "--no-archive";
    }
    else
    {
	vNoScanArchive=" ";
    }
    if (NoScanMailbox->isChecked())
    {
	vNoScanMailbox = "--no-mail";
    }
    else
    {
	vNoScanMailbox=" ";
    }
    if (NoScanPakedProg->isChecked())
    {
	vNoScanPakedProg = "--no-pack";
    }
    else
    {
	vNoScanPakedProg =" ";
    }
    
    if (LevelMaxArchive->isChecked())
    {
	vnDepthMaxArchive.setNum(sbDepthMaxArchive->value());
	vDepthMaxArchive = "--archive-level="+vnDepthMaxArchive;
    }
    else
    {	
	vDepthMaxArchive = " ";
    }
    if (LevelMaxFolder->isChecked())
    {
	vnDepthMaxFolder.setNum(sbDepthMaxFolder->value());
	vDepthMaxFolder = "--recursive-level="+vnDepthMaxFolder;
    }
    else
    {
	vDepthMaxFolder = " ";
    }
    if (ScanExtension->isChecked())
    {
	vScanExtension = "--ext="+leScanExtension->text();
    }
    else
    {
	vScanExtension = " ";
    }
    if (ExcludeExtension->isChecked())
    {
	vExcludeExtension = "--exclude-ext="+leExcludeExtension->text();
    }
    else
    {
	vExcludeExtension =" ";
    }
}


void frmprincipal::check_log()
{
    if (CreateLog->isChecked())
    {
	LogFolder->setEnabled(true);
	//LogFolder->setFocusEnabled(true);
	btnSeekLog->setEnabled(true);
    }
    else
    {
	LogFolder->setEnabled(false);
	//LogFolder->setFocus(false);
	btnSeekLog->setEnabled(false);	
    }
}

//PROCEDURE DES ACTIONS A ENTREPRENDRE
void frmprincipal::action_fichier()
{
	// cette procedure traite la partie action du logiciel et affecte une valeur aux différentes variables
    
	if (ActionToDo->currentItem()==0 && SuspectedFile->currentItem()==0) 
	{
	    vActionToDo="--action=disinfect";
	    vQuarantine=" ";
	    vSuspectCopy=" ";
	    vSuspectMove=" ";
	}
	else
	if (ActionToDo->currentItem()==0 && SuspectedFile->currentItem()==1) 
	{
	  vActionToDo="--action=disinfect";
	  vQuarantine="--quarantine="+vQuarantineFolder;
	  vSuspectCopy="--suspect-copy";
	  vSuspectMove=" ";
	}
	else
	if (ActionToDo->currentItem()==0 && SuspectedFile->currentItem()==2) 
               {
  	   vActionToDo="--action=disinfect";
 	   vQuarantine="--quarantine="+vQuarantineFolder;
	   vSuspectCopy=" ";
	   vSuspectMove="--suspect_move";
	}  
	else
                if (ActionToDo->currentItem()==1 && SuspectedFile->currentItem()==0) 
	{
	    vActionToDo="--action=delete";
	    vQuarantine=" ";
	    vSuspectCopy=" ";
	    vSuspectMove=" ";
	}
	else
	if (ActionToDo->currentItem()==1 && SuspectedFile->currentItem()==1) 
	{
	    vActionToDo="--action=delete"; 
 	   vQuarantine="--quarantine="+vQuarantineFolder;
	   vSuspectCopy="--suspect-copy";
	   vSuspectMove=" ";
	}
	else
	if (ActionToDo->currentItem()==1 && SuspectedFile->currentItem()==2)
	{
	  vActionToDo="--action=delete"; 
                  vQuarantine="--quarantine="+vQuarantineFolder;
	  vSuspectCopy=" ";
	  vSuspectMove="--suspect_move";
	}
	else
                if (ActionToDo->currentItem()==2 && SuspectedFile->currentItem()==0)
	{
	      vActionToDo="--action=quarantine";
    	      vQuarantine="--quarantine="+vQuarantineFolder;
	      vSuspectCopy=" ";
	      vSuspectMove=" ";
	}
	else
                if (ActionToDo->currentItem()==2 && SuspectedFile->currentItem()==1) 
	{
	      vActionToDo="--action=quarantine";
  	      vQuarantine="--quarantine="+vQuarantineFolder;
	      vSuspectCopy="--suspect-copy";
	      vSuspectMove=" ";
	}
	else
	 if (ActionToDo->currentItem()==2 && SuspectedFile->currentItem()==2) 
	 {
	       vActionToDo="--action=quarantine";
 	       vQuarantine="--quarantine="+vQuarantineFolder;
	       vSuspectCopy=" ";
	       vSuspectMove="--suspect_move";
	 }
}
    
void frmprincipal::valider()
{
	// cette procedure traite la partie "lancer le scan" et va chercher les différentes valeures dans les autres procedures
	recup_toutes_variables();
	//edit_rapport();
	action_fichier();
	showAnalyse();    
    }
    
void frmprincipal::showAnalyse()
{
    
               // vérification si l'action est mise en quarantaine
    
	//Lancement de la fenetre de scan
	QString text = leScanFolder->text();
	proc = new QProcess( this );
	proc->addArgument("bdscan");
	proc->addArgument( vActionToDo );
	proc->addArgument( vQuarantine );
	proc->addArgument( vSuspectCopy );
	proc->addArgument( vSuspectMove );
	proc->addArgument( vNoScanArchive );
	proc->addArgument( vNoScanMailbox ) ;
	proc->addArgument( vNoScanPakedProg );
	proc->addArgument( vDepthMaxArchive );
	proc->addArgument( vDepthMaxFolder );
	proc->addArgument( vScanExtension );
	proc->addArgument( vExcludeExtension );
                if (CreateLog->isChecked() && LogFolder->text()!="")
               {
                   vCreateLog="--log="+LogFolder->text()+"bdscan.log";
	   proc->addArgument( vCreateLog );
               }	  
               else
              {
              }
	proc->addArgument( text );
	if ( !proc->start() )
	{
	    erreur();
	}
	frmAnalyse * fnAna = new frmAnalyse(this);
	fnAna->exec();
}
    
//SAUVEGARDE DE LA CONFIGURATION

void frmprincipal::saveConfig()
{
	/*
      Récupération de toutes les valeures de l'application et préparation du fichier
      de configuration.
    */
	if (NoScanArchive->isChecked())
	{
	    vNoScanArchive = "1";
	}
	else
	{
	    vNoScanArchive = "0";
	}
	if (NoScanMailbox->isChecked())
	{
	    vNoScanMailbox = "1";
	}
	else
	{
	    vNoScanMailbox = "0";
	}
	if (NoScanPakedProg->isChecked())
	{
	    vNoScanPakedProg = "1";
	}
	else
	{
	    vNoScanPakedProg = "0";
	}
	if (LevelMaxArchive->isChecked())
	{
	    vLevelMaxArchive = "1";
	}
	else
	{
	    vLevelMaxArchive = "0";
	}
	
	if (LevelMaxFolder->isChecked())
	{
	    vLevelMaxFolder = "1";
	}
	else
	{
	    vLevelMaxFolder = "0";
	}
	
	if (ScanExtension->isChecked())
	{
	    vScanExtension = "1";
	}
	else
	{
	    vScanExtension = "0";
	}
	
	if (ExcludeExtension->isChecked())
	{
	    vExcludeExtension = "1";
	}
	else
	{
	    vExcludeExtension = "0";
	}
	
	if (ActiveAlert->isChecked())
	{
	    vActiveAlert = "1";
	}
	else
	{
	    vActiveAlert = "0";
	}
	QVariant ll = Language->currentItem();
	vLanguage = ll.toString();
	QVariant ww = Themes->currentItem();
	vThemes = ww.toString();
	QVariant gg = ActionToDo->currentItem();
	vActionToDo = gg.toString();
	QVariant hh = SuspectedFile->currentItem();
	vSuspectedFile = hh.toString();
	QVariant nn = sbDepthMaxArchive->value();
	vnDepthMaxArchive = nn.toString();
	QVariant oo = sbDepthMaxFolder->value();
	vnDepthMaxFolder = oo.toString();
	
	if (CreateLog->isChecked())
	{
	    vCreateLog = "1";
	}
	else
	{
	    vCreateLog = "0";
	}
	
	QVariant rr = CountDays->value();
	vCountDays = rr.toString();
	
	cScanExtension = leScanExtension->text();
	cExcludeExtension = leExcludeExtension->text();
	vQuarantineFolder = QuarantineFolder->text();
	vLogFolder = LogFolder->text();
	lng = Language->currentText();
                ths = Themes->currentText();
                vBdscan = lebdapp->text();
	if (rbmois->isChecked())
	{
	    vMois = "1";
	}
	else
	{
	    vMois = "0";
	}
	
	if (rbsemaine->isChecked())
	{
	    vSemaine = "1";
	}
	else
	{
	    vSemaine = "0";
	}	
	
                if (rbjours->isChecked())
	{
	    vJours = "1";
	}
	else
	{
	    vJours = "0";
	}
	
	if (rbheure->isChecked())
	{
	    vHeure = "1";
	}
	else
	{
	    vHeure = "0";
	}
	
	QFile fichier_conf( App_Folder + "/.bdfeui.conf");
	if ( !fichier_conf.open( IO_WriteOnly ) )
	    return;
	
	const int Indent = 4;
	
	QDomDocument doc;
	QDomElement root = doc.createElement("config");
	QDomElement noscanarchive = doc.createElement("noscanarchive");
	QDomElement noscanmailbox = doc.createElement("noscanmailbox");
	QDomElement noscanpakedprog = doc.createElement("noscanpakedprog");
	QDomElement levelmaxarchive = doc.createElement("levelmaxarchive");
	QDomElement valdepthmaxarchive = doc.createElement("valdepthmaxarchive");
	QDomElement levelmaxfolder = doc.createElement("levelmaxfolder");
	QDomElement valdepthmaxfolder = doc.createElement("valdepthmaxfolder");	
	QDomElement scanextension = doc.createElement("scanextension");
	QDomElement cscanextension = doc.createElement("cscanextension"); 
	QDomElement excludeextension = doc.createElement("excludeextension");
	QDomElement cexcludeextension = doc.createElement("cexcludeextension");
	QDomElement actiontodo = doc.createElement("actiontodo");
	QDomElement suspectedfile = doc.createElement("suspectedfile");
	QDomElement countdays = doc.createElement("countdays");
	QDomElement activealert = doc.createElement("activealert");
	QDomElement mois = doc.createElement("mois");
	QDomElement semaine = doc.createElement("semaine");
	QDomElement jours = doc.createElement("jours");	
	QDomElement heure = doc.createElement("heure");
	QDomElement bdscanfolder = doc.createElement("bdscanfolder");	
	QDomElement quarantinefolder = doc.createElement("quarantinefolder");
	QDomElement createlog = doc.createElement("createlog");
	QDomElement logfolder = doc.createElement("logfolder");
	QDomElement language = doc.createElement("language");
	QDomElement completelanguage = doc.createElement("completelanguage");	
	QDomElement themes = doc.createElement("themes");
	QDomElement completethemes = doc.createElement("completethemes");
	
	QDomText noscanarchiveText = doc.createTextNode(vNoScanArchive);
	QDomText noscanmailboxText = doc.createTextNode(vNoScanMailbox);
	QDomText noscanpakedprogText = doc.createTextNode(vNoScanPakedProg);
	QDomText levelmaxarchiveText = doc.createTextNode(vLevelMaxArchive);
	QDomText valdepthmaxarchiveText = doc.createTextNode(vnDepthMaxArchive);
	QDomText levelmaxfolderText = doc.createTextNode(vLevelMaxFolder);
	QDomText valdepthmaxfolderText = doc.createTextNode(vnDepthMaxFolder);
	QDomText scanextensionText = doc.createTextNode(vScanExtension);
	QDomText cscanextensionText = doc.createTextNode(cScanExtension);
	QDomText excludeextensionText = doc.createTextNode(vExcludeExtension);
	QDomText cexcludeextensionText = doc.createTextNode(cExcludeExtension);
	QDomText actiontodoText = doc.createTextNode(vActionToDo);
	QDomText suspectedfileText = doc.createTextNode(vSuspectedFile);
	QDomText countdaysText = doc.createTextNode(vCountDays);
	QDomText activealertText = doc.createTextNode(vActiveAlert);
	QDomText moisText = doc.createTextNode(vMois);
	QDomText semaineText = doc.createTextNode(vSemaine);
	QDomText joursText = doc.createTextNode(vJours);
	QDomText heureText = doc.createTextNode(vHeure);
	QDomText bdscanfolderText = doc.createTextNode(vBdscan);	
	QDomText quarantinefolderText = doc.createTextNode(vQuarantineFolder);
	QDomText createlogText = doc.createTextNode(vCreateLog);
	QDomText logfolderText = doc.createTextNode(vLogFolder);
	QDomText languageText = doc.createTextNode(vLanguage);
	QDomText completelanguageText = doc.createTextNode(lng);
	QDomText themesText = doc.createTextNode(vThemes);
	QDomText completethemesText = doc.createTextNode(ths);
	
	doc.appendChild(root);
	root.appendChild(noscanarchive);
	root.appendChild(noscanmailbox);
	root.appendChild(noscanpakedprog);
	root.appendChild(levelmaxarchive);
	root.appendChild(valdepthmaxarchive);
	root.appendChild(levelmaxfolder);
	root.appendChild(valdepthmaxfolder);
	root.appendChild(scanextension);
	root.appendChild(cscanextension);
	root.appendChild(excludeextension);
	root.appendChild(cexcludeextension);
	root.appendChild(actiontodo);
	root.appendChild(suspectedfile);
	root.appendChild(countdays);
	root.appendChild(activealert);
	root.appendChild(mois);
	root.appendChild(semaine);
	root.appendChild(jours);
	root.appendChild(heure);
	root.appendChild(bdscanfolder);
	root.appendChild(quarantinefolder);
	root.appendChild(createlog);
	root.appendChild(logfolder);
	root.appendChild(language);
	root.appendChild(completelanguage);
	root.appendChild(themes);
	root.appendChild(completethemes);
	
	noscanarchive.appendChild(noscanarchiveText);
	noscanmailbox.appendChild(noscanmailboxText);
	noscanpakedprog.appendChild(noscanpakedprogText);
	levelmaxarchive.appendChild(levelmaxarchiveText);
	valdepthmaxarchive.appendChild(valdepthmaxarchiveText);
	levelmaxfolder.appendChild(levelmaxfolderText);
	valdepthmaxfolder.appendChild(valdepthmaxfolderText);
	scanextension.appendChild(scanextensionText);
	cscanextension.appendChild(cscanextensionText);
	excludeextension.appendChild(excludeextensionText);
	cexcludeextension.appendChild(cexcludeextensionText);
	actiontodo.appendChild(actiontodoText);
	suspectedfile.appendChild(suspectedfileText);
	countdays.appendChild(countdaysText);
	activealert.appendChild(activealertText);
	mois.appendChild(moisText);
	semaine.appendChild(semaineText);
	jours.appendChild(joursText);
	heure.appendChild(heureText);
	bdscanfolder.appendChild(bdscanfolderText);
	quarantinefolder.appendChild(quarantinefolderText);
	createlog.appendChild(createlogText);
	logfolder.appendChild(logfolderText);
	language.appendChild(languageText);
	completelanguage.appendChild(completelanguageText);	
	themes.appendChild(themesText);
	completethemes.appendChild(completethemesText);
	
	QTextStream ligne( &fichier_conf );
	doc.save(ligne, Indent);
    }
    
void frmprincipal::rien()
{
}
   
void frmprincipal::erreur()
{
	QMessageBox::critical( 0,
			       tr("Erreur Fatal"),
			       tr("Impossible de lancer la commande bdscan."),
			       tr("Quitter") );
	exit( -1 );
}
    
void frmprincipal::UpdateVirusList()
{
	// vérifie l'existence de mise à jour de la base virale sur Internet, la connection internet doit etre active
	proc = new QProcess( this );
	proc->addArgument( "bdscan" );	
	proc->addArgument( "--update" );
                connect( proc, SIGNAL(readyReadStdout()), this, SLOT(lectureupdate()));
	if ( !proc->start() )
	{
	    erreur();
	}
	btnUpdateNow->setEnabled(false);
	btnScan->setEnabled(false);
	btnSaveConfig->setEnabled(false);
	btnQuitter->setEnabled(false);
	timer->start( 5000, FALSE);
	connect( timer, SIGNAL(timeout()), SLOT(etat()) );   
	connect( proc, SIGNAL(processExited()), this, SLOT(changelabel()) );
}

void frmprincipal::lectureupdate()
{  
    do 
    {
	leupdate->clear();
	ligneA = proc->readLineStdout();
	if (ligneA.startsWith("/"))
	{
                   QString test1 = ligneA.mid(0,50);
	   QString test2 = ligneA.right(20);
	   QString test3 = test1 +" ... "+ test2;
                   leupdate->setText(test3); 
                }
	else
	if (ligneA.startsWith("N"))
	{
	  leupdate->setText(tr("Aucune mise à jour disponible !"));  
	}
	else
	if ( ligneA.startsWith("E"))
	{
	    leupdate->setText(tr("Erreur - Impossible d'ouvrir le fichier"));  
	}
    }
    while (proc->canReadLineStdout());
}
    
void frmprincipal::changelabel()
{
	if (timer->isActive())
	{
	    timer->stop();	
	    pbUpdateNow->setProgress(100);
	    btnUpdateNow->setEnabled(true);
	    btnScan->setEnabled(true);
	    btnSaveConfig->setEnabled(true);
	    btnQuitter->setEnabled(true);
	}
	cptPB=1;
	timer->stop();
}
    
void frmprincipal::etat()
{
	cptPB+=1;
	pbUpdateNow->setProgress(cptPB);
}
    
void frmprincipal::readFromStdout() 
{
	//tbMiscInformations->clear();
	while (proc->canReadLineStdout()) 
	{
	    QString line = proc->readLineStdout();
	    tbMiscInformations->append(line);
	}
}
    
void frmprincipal::enabledsbDepthMaxArc()
{
	if (LevelMaxArchive->isChecked())
	{
	    sbDepthMaxArchive->setEnabled(true);
	}
	else
	{
	    sbDepthMaxArchive->setEnabled(false);
	}
}
   
void frmprincipal::enabledsbDepthMaxFold()
{
	if (LevelMaxFolder->isChecked())
	{
	    sbDepthMaxFolder->setEnabled(true);
	}
	else
	{
	    sbDepthMaxFolder->setEnabled(false);
	}	
}
       
void frmprincipal::recuperation_lng()
{
	lng = Language->currentText();
}
    
    
void frmprincipal::recuperation_ths()
{
	ths = Themes->currentText(); 
}
    
    


void frmprincipal::exclure()
{
    if  (ExcludeExtension->isChecked())
    {
	leExcludeExtension->setEnabled(true);
	leExcludeExtension->setFocus();
    }
    else
    {
	leExcludeExtension->setEnabled(false);  
	leScanFolder->setFocus();       
    }
}

void frmprincipal::auto_update()
{
    /* Vérification de l'existence du fichier dans les quatres répertoires cron.
          Si le fichier existe alors le détruire ! */
     QFile file;
     file.setName( "bdupdate.sh" );    
     if ( !cron_daily.exists() )
     {
	 
     }
     else
     {
       QDir::setCurrent( "/etc/cron.daily/"); 
       if (file.exists()){  file.remove();}
      }
     
     if ( !cron_hourly.exists() )
     {

     }
     else
     {
       QDir::setCurrent( "/etc/cron.hourly/"); 
       if (file.exists()){  file.remove();}
     }
     
     if ( !cron_monthly.exists() )
     {

     }
     else
     {
       QDir::setCurrent( "/etc/cron.monthly/"); 
       if (file.exists()){  file.remove();}
     }
     
     if ( !cron_weekly.exists() )
     {

     }
     else
     {
       QDir::setCurrent( "/etc/cron.weekly/"); 
       if (file.exists()){  file.remove();}
     }    
}


void frmprincipal::check_cron()
{
    QString bdscan_rep;
    QString shell;
   auto_update();
   //on vérifie si le chemin vers bdscan est renseigné
   if (lebdapp->text()=="")
   {
           QMessageBox::warning( 0, tr("BitDefender Front End 1.1"), tr("Renseigner le chemin vers l'application bdscan !"), tr("Fermer") );
           lebdapp->setFocus(); 
   }
   bdscan_rep = lebdapp->text()+"bdscan";
   shell = "#!/bin/sh\nBDSCAN="+bdscan_rep+"\n$BDSCAN --update\n";
   //test du répertoire cron choisi par l'utilisateur et écriture du fichier shell
   if (rbmois->isChecked())
   { 
       if ( !cron_monthly.exists() )
     {
         QMessageBox::warning( 0, tr("BitDefender Front End 1.1"), tr("ATTENTION le répertoire cron.monthly n'existe pas !"), tr("Fermer"));
     }
     else
     {
       QFile fichier_shell("/etc/cron.monthly/bdupdate.sh");
       if ( !fichier_shell.open( IO_WriteOnly ) ) return;
       QTextStream ligne( &fichier_shell );
       ligne << shell;
       fichier_shell.close(); 
       proc = new QProcess( this );
       proc->addArgument( "chmod" );	
       proc->addArgument( "u+x" );
       proc->addArgument("/etc/cron.monthly/bdupdate.sh");
       connect( proc, SIGNAL(readyReadStdout()), this, SLOT(rien()));
       if ( !proc->start() )
       {
               erreur();
       }
     }
   }
   
   if (rbsemaine->isChecked())
   {
      if (!cron_weekly.exists())
       {
	QMessageBox::warning( 0, tr("BitDefender Front End 1.1"), tr("ATTENTION le répertoire cron.weekly n'existe pas !"), tr("Fermer"));  
      }
      else
      {
      QFile fichier_shell("/etc/cron.weekly/bdupdate.sh");
       if ( !fichier_shell.open( IO_WriteOnly ) ) return;
       QTextStream ligne( &fichier_shell );
       ligne << shell;
       fichier_shell.close(); 
       proc = new QProcess( this );
       proc->addArgument( "chmod" );	
       proc->addArgument( "u+x" );
       proc->addArgument("/etc/cron.weekly/bdupdate.sh");
       connect( proc, SIGNAL(readyReadStdout()), this, SLOT(rien()));
       if ( !proc->start() )
       {
               erreur();
       }
   }
   }
   if (rbjours->isChecked())
   {
       if (!cron_daily.exists())
       {
	QMessageBox::warning( 0, tr("BitDefender Front End 1.1"), tr("ATTENTION le répertoire cron.daily n'existe pas !"), tr("Fermer"));     
       }
       else
       {
        QFile fichier_shell("/etc/cron.daily/bdupdate.sh");
        if ( !fichier_shell.open( IO_WriteOnly ) ) return;
        QTextStream ligne( &fichier_shell );
        ligne << shell;
        fichier_shell.close(); 
       proc = new QProcess( this );
       proc->addArgument( "chmod" );	
       proc->addArgument( "u+x" );
       proc->addArgument("/etc/cron.daily/bdupdate.sh");
       connect( proc, SIGNAL(readyReadStdout()), this, SLOT(rien()));
       if ( !proc->start() )
       {
               erreur();
       }
      }
     }
   if (rbheure->isChecked())
   {
       if (!cron_hourly.exists())
       {
      QMessageBox::warning( 0, tr("BitDefender Front End 1.1"), tr("ATTENTION le répertoire cron.hourly n'existe pas !"), tr("Fermer"));	   
       }
       else
       {
         QFile fichier_shell("/etc/cron.hourly/bdupdate.sh");
         if ( !fichier_shell.open( IO_WriteOnly ) ) return;
         QTextStream ligne( &fichier_shell );
         ligne << shell;
         fichier_shell.close();  
       proc = new QProcess( this );
       proc->addArgument( "chmod" );	
       proc->addArgument( "u+x" );
       proc->addArgument("/etc/cron.hourly/bdupdate.sh");
       connect( proc, SIGNAL(readyReadStdout()), this, SLOT(rien()));
       if ( !proc->start() )
       {
               erreur();
       }
       }
   }
   //sauvegarde des param�res dans le fichier de configuration
   saveConfig();
}
